Name:           nacl
# http://nacl.cr.yp.to/
URL:            http://nacl.cace-project.eu/
Version:        20110221
Release:        18%{?dist}
License:        Public Domain
Group:          Development/Libraries
Summary:        Networking and Cryptography library
BuildRequires:  e2fsprogs
Source0:        http://hyperelliptic.org/nacl/nacl-%{version}.tar.bz2
Source1:        curvecpclient.1
Source2:        curvecpserver.1
Source3:        curvecpmakekey.1
Source4:        curvecpmessage.1
Source5:        curvecpprintkey.1
Source6:        nacl-sha256.1
Source7:        nacl-sha512.1
Patch0:         nacl-20110221-dist-flags.patch
Patch1:         nacl-20110221-build-dir.patch
Patch2:         nacl-20110221-noexec-stack.patch
# Fix for secondary arches
Patch3:         nacl-20110221-cpufreq-fallback.patch
Patch4:         nacl-20110221-abi-len-limit.patch

%description
NaCl (pronounced "salt") is a new easy-to-use high-speed software library for
network communication, encryption, decryption, signatures, etc. NaCl's goal
is to provide all of the core operations needed to build higher-level
cryptographic tools.

%package devel
Summary:        Development files
Group:          Development/Libraries
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
Include files and devel library.

%package static
Summary:        Static version of the NaCl library
Group:          Development/Libraries
Provides:       nacl-static%{?_isa} = %{version}-%{release}
Requires:       %{name}-devel%{?_isa} = %{version}-%{release}

%description static
Statically linkable version of the NaCl library.

%prep
%setup -q
%patch0 -p1 -b .dist-flags
%patch1 -p1 -b .build-dir
%patch2 -p1 -b .noexec-stack
%patch3 -p1 -b .cpufreq-fallback
%patch4 -p1 -b .abi-len-limit

sed -i 's|\${CFLAGS}|%{optflags} -fPIC|g' okcompilers/c okcompilers/cpp

%build
./do
# shared library
gcc -shared -fPIC -Wl,-soname,libnacl.so.0 -o libnacl.so.0.0.0 \
  -Wl,-whole-archive build/fedora/lib/*/libnacl.a -Wl,-no-whole-archive \
  build/fedora/lib/*/cpucycles.o build/fedora/lib/*/randombytes.o

%install
mkdir -p %{buildroot}%{_includedir}/%{name}
install -m 0644 -t %{buildroot}%{_includedir}/%{name} build/fedora/include/*/*.h
mkdir -p %{buildroot}%{_libdir}/
install -m 0644 -t %{buildroot}%{_libdir} build/fedora/lib/*/*.a

# install cpucycles.o and randombytes.o
install -m 0644 -t %{buildroot}%{_libdir} build/fedora/lib/*/cpucycles.o build/fedora/lib/*/randombytes.o

# install shared library
install -m 0755 -t %{buildroot}%{_libdir} libnacl.so.*
pushd %{buildroot}%{_libdir}
ln -s libnacl.so.0.0.0 libnacl.so.0
ln -s libnacl.so.0 libnacl.so
popd

mkdir -p %{buildroot}%{_mandir}/man1
install -m 0644 -t %{buildroot}%{_mandir}/man1 %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE7}
mkdir -p %{buildroot}%{_bindir}
rm -f build/fedora/bin/ok*
install -m 0755 -t %{buildroot}%{_bindir} build/fedora/bin/*

%files
%{_libdir}/libnacl.so.*
%{_bindir}/*
%{_mandir}/man1/*

%files static
%{_libdir}/libnacl.a
%{_libdir}/cpucycles.o
%{_libdir}/randombytes.o

%files devel
%{_libdir}/libnacl.so
%{_includedir}/nacl

%changelog
* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 20110221-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 20110221-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 20110221-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 20110221-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Tue Nov  3 2015 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-14
- Fixed shared library to export symbols from all objects
- Explicitly set -fPIC and not relying on default CFLAGS
  Related: rhbz#1276066

* Thu Oct 29 2015 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-13
- Added shared library, moved static objects to 'static' subpackage
  Resolves: rhbz#1276066

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20110221-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon May 11 2015 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-11
- Fixed sed optflags patching to work with new distro CFLAGS
- Rebuilt with new distro CFLAGS (PIC)
- Fixed typo in dist-flags patch
- Limit length of ABI string (by abi-len-lmit patch)

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20110221-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20110221-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Aug 19 2013 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-8
- The cpucycles.o and randombytes.o moved outside the archive

* Thu Aug  8 2013 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-7
- Added cpucycles.o and randombytes.o to libnacl.a archive
  Resolves: rhbz#994236

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20110221-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Feb 15 2013 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-5
- Fixed packaging of devel subpackage not to own debuginfo files
  Resolves: rhbz#911405

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20110221-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Sep  6 2012 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-3
- Fixed build on secondary arches (cpufreq-fallback patch)

* Tue Sep  4 2012 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-2
- Updated URL

* Mon Jul 02 2012 Jaroslav Škarvada <jskarvad@redhat.com> - 20110221-1
- Initial release
